﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
//using System.Threading.Tasks;
using System.Runtime.InteropServices;
using SAP_Tutorial;
using System.Windows;
using CrystalDecisions.CrystalReports.Engine;
using System.IO;
using System.Reflection;

namespace SAP_TutorialLib
{
    [ComVisible(true),
    InterfaceType(ComInterfaceType.InterfaceIsDual),
    Guid("CB6D2850-161F-48F0-9AD9-B271312C2094")]
    public interface ISAP_Tutorial : IDisposable
    {
        #region --- Functions ---
        [DispId(1)]
        void showReport();
        #endregion
    }

    [ComVisible(true), 
    ClassInterface(ClassInterfaceType.None), 
    Guid("4CB812CC-D336-43A7-BED2-D21F10E7779F")]
    public class SAP_Tutorial: ISAP_Tutorial
    {
        MainWindow mainWin = null;
        ReportDocument RepDoc = null;

        public SAP_Tutorial()
        {
        }

        public void Dispose()
        {
            if(mainWin != null)
            {
                mainWin.Close();
                mainWin = null;
            }
            if (RepDoc != null)
            {
                RepDoc.Close();
                RepDoc.Dispose();
            }
            GC.SuppressFinalize(this);
        }

        public void showReport()
        {
            try
            {
                string reportPath = Path.Combine(Environment.CurrentDirectory , @"rpt\test.rpt");
                ReportDocument RepDoc = new ReportDocument();
                RepDoc.Load(reportPath);
                mainWin = new MainWindow(RepDoc);
                mainWin.Show();

                /* 
                Application app = new Application();
                app.Run(new MainWindow(RepDoc));
                */
            }
            catch (Exception ex) 
            {
                MessageBox.Show(ex.Message);
                throw;
            }
        }
    }
}
